from math import log2, ceil, floor


def gen(pref):
    if len(pref) == m:
        perm.append(pref)
        return
    for nxt in range(m):
        if not used[nxt]:
            used[nxt] = True
            gen(pref + [nxt])
            used[nxt] = False


def solve(alg):
    mem = [-1] * (2 ** k)
    l = 0
    r = 0
    res = 0
    for color in alg:
        while color in targ_mem[r:]:
            l = targ_mem.index(color, r)
            r = l
            while r < len(targ_mem) and targ_mem[r] == color:
                r += 1
            res += howmany(l, r, color, mem)
    return res


def howmany(l, r, color, mem):
    if mem[:l].count(-1) == l:
        l = 0
    if l == 0:
        l2 = 0
    else:
        l2 = pow(2, floor(log2(l)))

    if r == 0:
        r2 = 0
    else:
        r2 = pow(2, ceil(log2(2)))

    if mem[r + 1:r2 + 1] == r2 - r - 1:
        r = r2
    if l and mem[l2:l] == l - l2:
        l = l2

    if l == 0:
        l3 = 0
    else:
        l3 = pow(2, ceil(log2(l)))

    if r == 0:
        r3 = 0
    else:
        r3 = pow(2, floor(log2(r)))
    if l3 % (r3 - l3 + 1):
        return r - l
    else:
        return bin(r3 - l3 + 1).count("1") + abs(r - r3) + abs(l - l3)


k, n, m = map(int, input().split())
targ_mem = []
for i in range(n):
    c, v = map(int, input().split())
    targ_mem.extend(c * [v - 1])
used = [False] * m
perm = []
gen([])
ans = 10 ** 9 + 7
for x in perm:
    ans = min(solve(x), ans)
print(ans)
'''
3 3 2
1 1
2 2
5 1


3 5 3
1 2
1 1
1 3
1 1
4 1
'''
